/* This is -*- ObjC -*-)

   Contact.h   
   \author: Bjrn Giesler <giesler@ira.uka.de>
   
   
   
   $Author: bjoern $
   $Locker:  $
   $Revision: 1.1.1.1 $
   $Date: 2003/08/28 15:54:43 $
 */

#ifndef CONTACT_H
#define CONTACT_H

/* system includes */
#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

/* my includes */
/* (none) */

typedef enum {
  ScreenNameBeginsWithLastName,
  ScreenNameBeginsWithFirstName
} ScreenNameType;

typedef enum {
  AddressFieldPOBox = 0,
  AddressFieldExtendedAddress = 1,
  AddressFieldStreet = 2,
  AddressFieldCity = 3,
  AddressFieldState = 4,
  AddressFieldZipCode = 5,
  AddressFieldCountry = 6
} AddressField;

@interface Contact: NSObject
{
  int _id;
  NSMutableDictionary *_info;
  NSString *_dir;
}

+ (ScreenNameType) screenNameType;
+ (void) setScreenNameType: (ScreenNameType) type;
+ (int) addressIndexForAddressField: (NSString*) field;
+ (NSString*) addressFieldForAddressIndex: (int) index;

- initWithId: (int) i;
- initWithDictionary: (NSDictionary*) dict
		  id: (int) i;
- initWithContentsOfFile: (NSString*) filename;
- (void) setDictionary: (NSDictionary*) dict;
- (NSDictionary*) dictionary;

- (void) writeToFile;
- (void) writeToFileInDirectory: (NSString*) directory;

- (int) getId;
- (NSArray*) valuesForKey: (NSString*) key
		parameter: (id) parameter;
- (NSString*) valueForKey: (NSString*) key
		parameter: (id) parameter
		    index: (int) index;
- (void) setValues: (NSArray*) values
	    forKey: (NSString*) key
	 parameter: (id) parameter;
- (void) setValue: (NSString*) value
	   forKey: (NSString*) key
	parameter: (id) parameter
	  atIndex: (int) index;

- (NSString*) screenName;
- (int) screenNameCompare: (Contact*) anotherContact;

- (NSString*) firstName;
- (NSString*) lastName;
- (NSString*) title;

- (NSString*) email;
- (NSString*) phone;

- (NSImage*) image;
- (NSString*) addressRoad;
- (NSString*) addressPostalCode;
- (NSString*) addressState;
- (NSString*) addressCity;

- (NSString*) fileName;

- (void) setImage: (NSImage*) image;
- (BOOL) takeImageFromFile: (NSString*) filename;
@end

#endif /* CONTACT_H */
