/* This is -*- ObjC -*-)

   ContactView.h   
   \author: Bjrn Giesler <giesler@ira.uka.de>
   
   
   
   $Author: bjoern $
   $Locker:  $
   $Revision: 1.1.1.1 $
   $Date: 2003/08/28 15:54:43 $
 */

#ifndef CONTACTVIEW_H
#define CONTACTVIEW_H

/* system includes */
#include <AppKit/AppKit.h>

/* my includes */
#include "Contact.h"
#include "ContactViewCells.h"

@interface ContactView: NSView
{
  Contact *contact;

  NSFont *nameFont, *labelFont, *entryFont;

  NSTextFieldCell *firstNameCell, *lastNameCell, *titleCell;
  NSTextFieldCell *emailLabel, *emailCell;
  NSTextFieldCell *phoneLabel, *phoneCell;
  NSTextFieldCell *addressLabel, *addressCell;
  NSImageCell *photoCell;
  NSImageCell *addCell;
  NSMutableArray *labels;

  NSText *textObject;
  id editingCell;

  NSMutableArray *allCells;

  BOOL editable;
  id delegate;

  BOOL fillsSuperview;
  NSSize contentSize;
  BOOL selfResized;
}

- initWithFrame: (NSRect) aRect;

- (void) layout;
- (BOOL) fillsSuperview;
- (void) setFillsSuperview: (BOOL) yesno;
- (void) calcSize;

- (void) setContact: (Contact*) contact;
- (Contact*) contact;

- (void) setDelegate: (id) anObject;
- (id) delegate;

- (void) drawRect: (NSRect) rect;

- (BOOL) isEditable;
- (void) setEditable: (BOOL) yn;

- (void) beginEditingInCell: (id) c
	     becauseOfEvent: (NSEvent*) e;
- (void) endEditing;
- (void) runActionForCell: (id) c
	   becauseOfEvent: (NSEvent*) e;

/*
  Utility methods
*/
- (float) maxLabelWidthInRect: (NSRect) rect;
- (NSCell*) cellContainingPoint: (NSPoint)aPoint;

/*
  Event methods
  These get called when the user clicks on certain contact
  fields. Will be transparently forwarded to the delegate.
*/
- (void) clickedOnURL: (id) cell;
- (void) clickedOnEmail: (id) cell;

- (void) superviewFrameChanged: (NSNotification*) note;

@end

#endif /* CONTACTVIEW_H */
