/* This is -*- ObjC -*-)

   ContactViewCells.h   
   \author: Bjrn Giesler <giesler@ira.uka.de>
   
   
   
   $Author: giesler $
   $Locker:  $
   $Revision: 1.3 $
   $Date: 2002/08/19 08:41:28 $
 */

#ifndef CONTACTVIEWCELLS_H
#define CONTACTVIEWCELLS_H

/* system includes */
#include <AppKit/AppKit.h>
#include "Contact.h"

/* my includes */
/* (none) */

@interface ContactDataCell: NSTextFieldCell
{
  Contact *contact;
  NSString *representedKey;
  NSArray *representedParameters;
  id substitute;
  int valueIndex;
  NSRect _rect;
  SEL selector;
  id target;
}
- (void) drawWithFrame: (NSRect) frame
		inView: (NSView*) view;
- (void) drawInView: (NSView*) view;
- (void) setRect: (NSRect) r;
- (void) moveDownBy: (float) y;
- (NSRect) rect;
- (void) setRepresentsKey: (NSString*) key
	     valueAtIndex: (int) v
	       parameters: (NSArray*) parameters;
- (void) setContact: (Contact*) c;
- (void) updateContact;

- (void) setSubstitute: (id) subst;
- (id) substitute;
- (BOOL) displaysSubstitute;

- (NSArray*) representedParameters;

- (void) setActionSelector: (SEL) aSelector;
- (void) setActionTarget: (id) anObject;
- (void) invokeAction;
@end

@interface ContactImageCell: NSImageCell
{
  Contact *contact;
  NSString *representedKey;
  NSArray *representedParameters;
  id substitute;
  int valueIndex;
  NSRect _rect;
  SEL selector;
  id target;
}
- (void) drawWithFrame: (NSRect) frame
		inView: (NSView*) view;
- (void) drawInView: (NSView*) view;
- (void) setRect: (NSRect) r;
- (void) moveDownBy: (float) y;
- (NSRect) rect;
- (void) setRepresentsKey: (NSString*) key
	     valueAtIndex: (int) v
	       parameters: (id) parameters;
- (void) setContact: (Contact*) c;
- (void) updateContact;

- (void) setSubstitute: (id) subst;
- (id) substitute;
- (BOOL) displaysSubstitute;

- (id) representedParameters;

- (void) setActionSelector: (SEL) aSelector;
- (void) setActionTarget: (id) anObject;
- (void) invokeAction;
@end

#endif /* CONTACTVIEWCELLS_H */
