/* This is -*- ObjC -*-)

   ContactViewLayouter.h   
   \author: Bjrn Giesler <giesler@ira.uka.de>
   
   Superclass for ContactView{Display,Edit}Layouter
   
   $Author: giesler $
   $Locker:  $
   $Revision: 1.3 $
   $Date: 2002/08/19 08:41:28 $
 */

#ifndef CONTACTVIEWLAYOUTER_H
#define CONTACTVIEWLAYOUTER_H

/* system includes */
#include <Foundation/Foundation.h>
#include <AppKit/AppKit.h>

/* my includes */
#include "Contact.h"
#include "ContactViewCells.h"

@interface ContactViewLayouter: NSObject
+ (void) init;
+ (NSMutableArray*) allCells;

+ (NSArray*) defaultAddressLayout;
+ (NSArray*) addressLayoutForName: (NSString*) name;
+ (NSString*) addressStringConstant: (NSString*) str;
+ (NSArray*) layoutForAddress: (NSDictionary*) dict;

+ (NSFont*) nameFont;
+ (NSFont*) labelFont;
+ (NSFont*) entryFont;
+ (NSArray*) doLayoutForContact: (Contact*) c
		      needsSize: (NSSize*) s
			 target: (id) anObject;

+ (NSTextFieldCell*) makeLabel: (NSString*) title;
+ (ContactDataCell*) makeDataFieldForKey: (NSString*) key;
+ (ContactDataCell*) makeDataFieldForKey: (NSString*) key
			      valueIndex: (int) v;
+ (ContactDataCell*) makeDataFieldForKey: (NSString*) key
			      valueIndex: (int) v
			      parameters: (id) arr;

+ (float) maxLabelWidth: (NSArray*) arr
		forFont: (NSFont*) font;

@end

#endif /* CONTACTVIEWLAYOUTER_H */
