/* This is -*- ObjC -*- */

#include <AppKit/AppKit.h>
#include "Contact.h"
#include "ContactView.h"

@interface Controller : NSObject
{
  NSFileManager *fm;
  NSArray *allCache;
  
  id contactView, scrollView, clipView;
  id groupsBrowser;
  id servicesMenu;
  id editButton;

  id cNameLabel;
  id cRoadLabel, cCityLabel, cPostalCodeLabel, cStateLabel;
  id cImage;

  // Hack!
  id lastCell;
  NSString *lastCellLastValue;
}

+ (NSString*) databaseRoot;

- (NSArray *) groupNames;
- (BOOL) renameGroup: (NSString*) oldName
		  to: (NSString*) newName;
- (NSArray *) contactsInGroup: (NSString*) group;
- (void) linkContactAtRow: (int) contactRow
	     toGroupAtRow: (int) groupRow;
- (void) displayContact: (Contact*) aContact;
- (int) nextValidContactId;
- (void) deleteContact: (Contact *) contact
	     fromGroup: (NSString *) group
    askForConfirmation: (BOOL) confirm;
- (void) deleteContact: (Contact *) contact;
- (void) invalidateCache;

- (void) doToggleContactEditable: (id) sender;
- (void) doCreateContact: (id) sender;
- (void) doCreateGroup: (id) sender;
- (void) doDeleteGroup: (id) sender;
@end
